<?xml version="1.0" encoding="UTF-8"?>
<interface>
  <menu id="primary_menu_popover">
    <section>
      <attribute name="label" translatable="yes">List Contacts By:</attribute>
      <item>
        <attribute name="label" translatable="yes">First Name</attribute>
        <attribute name="action">win.sort-on</attribute>
        <attribute name="target">firstname</attribute>
      </item>
      <item>
        <attribute name="label" translatable="yes">Surname</attribute>
        <attribute name="action">win.sort-on</attribute>
        <attribute name="target">surname</attribute>
      </item>
    </section>
    <section>
      <item>
        <attribute name="label" translatable="yes">Import From File…</attribute>
        <attribute name="action">app.import</attribute>
      </item>
      <item>
        <attribute name="label" translatable="yes">Export All Contacts…</attribute>
        <attribute name="action">app.export-all</attribute>
      </item>
    </section>
    <section>
      <item>
        <attribute name="label" translatable="yes">Preferences</attribute>
        <attribute name="action">app.show-preferences</attribute>
      </item>
      <item>
        <attribute name="label" translatable="yes">Keyboard Shortcuts</attribute>
        <attribute name="action">win.show-help-overlay</attribute>
      </item>
      <item>
        <attribute name="label" translatable="yes">Help</attribute>
        <attribute name="action">app.help</attribute>
      </item>
      <item>
        <attribute name="label" translatable="yes">About Contacts</attribute>
        <attribute name="action">app.about</attribute>
      </item>
    </section>
  </menu>

  <menu id="contact_hamburger_menu_popover">
    <section>
      <item>
        <attribute name="label" translatable="yes">Mark as Favorite</attribute>
        <attribute name="action">win.mark-favorite</attribute>
        <attribute name="hidden-when">action-disabled</attribute>
      </item>
      <item>
        <attribute name="label" translatable="yes">Unmark as Favorite</attribute>
        <attribute name="action">win.unmark-favorite</attribute>
        <attribute name="hidden-when">action-disabled</attribute>
      </item>
      <item>
        <attribute name="label" translatable="yes">Share as QR Code</attribute>
        <attribute name="action">win.show-contact-qr-code</attribute>
      </item>
    </section>
    <section>
      <item>
        <attribute name="label" translatable="yes">Delete Contact</attribute>
        <attribute name="action">win.delete-contact</attribute>
      </item>
    </section>
  </menu>

  <template class="ContactsMainWindow" parent="AdwApplicationWindow">
    <property name="default_width">800</property>
    <property name="default_height">600</property>
    <property name="width-request">360</property>
    <property name="height-request">240</property>
    <property name="icon_name">gnome-contacts</property>

    <child>
      <object class="GtkShortcutController">
        <property name="scope">global</property>
        <child>
          <object class="GtkShortcut">
            <property name="trigger">&lt;Control&gt;n</property>
            <property name="action">action(win.new-contact)</property>
          </object>
        </child>
        <child>
          <object class="GtkShortcut">
            <property name="trigger">&lt;Control&gt;f</property>
            <property name="action">action(win.focus-search)</property>
          </object>
        </child>
        <child>
          <object class="GtkShortcut">
            <property name="trigger">Escape</property>
            <property name="action">action(win.edit-contact-cancel)</property>
          </object>
        </child>
        <child>
          <object class="GtkShortcut">
            <property name="trigger">&lt;Control&gt;Return</property>
            <property name="action">action(win.edit-contact-save)</property>
          </object>
        </child>
      </object>
    </child>

    <child>
      <object class="AdwToastOverlay" id="toast_overlay">
        <child>
          <object class="AdwNavigationSplitView" id="content_box">
            <property name="sidebar-width-fraction">0.3</property>
            <property name="min-sidebar-width">260</property>
            <property name="max-sidebar-width">360</property>
            <signal name="notify::collapsed" handler="on_collapsed"/>
            <signal name="notify::show-content" handler="on_show_content"/>
            <property name="sidebar">
              <object class="AdwNavigationPage" id="list_pane_page">
                <property name="title" translatable="yes">Contacts</property>
                <property name="name">list-pane</property>
                <property name="child">
                  <object class="AdwToolbarView">
                    <child type="top">
                      <object class="AdwHeaderBar" id="left_header">
                        <child type="start">
                          <object class="GtkButton" id="add_button">
                            <property name="tooltip-text" translatable="yes">Add New Contact</property>
                            <property name="icon-name">list-add-symbolic</property>
                            <property name="action-name">win.new-contact</property>
                          </object>
                        </child>

                        <child type="end">
                          <object class="GtkMenuButton" id="primary_menu_button">
                            <property name="menu-model">primary_menu_popover</property>
                            <property name="primary">True</property>
                            <property name="tooltip_text" translatable="yes">Main Menu</property>
                            <property name="icon-name">open-menu-symbolic</property>
                          </object>
                        </child>
                        <child type="end">
                          <object class="GtkButton" id="selection_button">
                            <property name="icon-name">selection-mode-symbolic</property>
                            <property name="tooltip-text" translatable="yes">Select Contacts</property>
                            <signal name="clicked" handler="on_selection_button_clicked"/>
                          </object>
                        </child>
                        <child type="end">
                          <object class="GtkButton" id="select_cancel_button">
                            <property name="visible">False</property>
                            <property name="label" translatable="yes">Cancel</property>
                            <property name="tooltip_text" translatable="yes">Cancel Selection</property>
                            <property name="can-shrink">True</property>
                          </object>
                        </child>
                      </object>
                    </child>
                    <child type="top">
                      <object class="AdwBin">
                        <style>
                          <class name="toolbar"/>
                        </style>
                        <property name="child">
                          <object class="GtkSearchEntry" id="filter_entry">
                            <property name="placeholder-text" translatable="yes">Search contacts</property>
                            <signal name="search-changed" handler="filter_entry_changed"/>
                          </object>
                        </property>
                      </object>
                    </child>
                    <child>
                      <object class="GtkStack" id="list_pane_stack">
                        <!-- The loading spinner page -->
                        <child>
                          <object class="GtkBox">
                            <property name="orientation">vertical</property>
                            <property name="homogeneous">True</property>
                            <property name="valign">center</property>
                            <property name="vexpand">True</property>
                            <child>
                              <object class="GtkSpinner">
                                <property name="spinning">True</property>
                                <property name="valign">end</property>
                                <property name="halign">center</property>
                              </object>
                            </child>
                            <child>
                              <object class="GtkLabel" id="label1">
                                <property name="valign">start</property>
                                <property name="halign">center</property>
                                <property name="label" translatable="yes">Loading</property>
                              </object>
                            </child>
                          </object>
                        </child>
                        <!-- The list pane with the actual contacts -->
                        <child>
                          <object class="GtkBox" id="list_pane">
                            <property name="orientation">vertical</property>
                            <child>
                              <object class="AdwBin" id="contacts_list_container">
                                <property name="hexpand">True</property>
                                <property name="vexpand">True</property>
                              </object>
                            </child>
                          </object>
                        </child>
                      </object>
                    </child>
                    <child type="bottom">
                      <object class="GtkRevealer" id="actions_bar">
                        <property name="reveal-child">False</property>
                        <property name="transition-type">slide-up</property>
                        <property name="child">
                          <object class="GtkBox">
                            <style>
                              <class name="toolbar"/>
                            </style>
                            <property name="orientation">horizontal</property>
                            <child>
                              <object class="GtkBox">
                                <property name="halign">start</property>
                                <property name="hexpand">True</property>
                                <property name="spacing">6</property>
                                <property name="margin-end">6</property>
                                <child>
                                  <object class="GtkButton" id="export_button">
                                    <property name="label" translatable="yes" comments="Export refers to the verb">Export</property>
                                    <property name="tooltip-text" translatable="yes">Export Selected Contacts</property>
                                    <property name="action-name">win.export-marked-contacts</property>
                                    <property name="can-shrink">True</property>
                                  </object>
                                </child>
                                <child>
                                  <object class="GtkButton" id="link_button">
                                    <property name="focus_on_click">False</property>
                                    <property name="label" translatable="yes" comments="Link refers to the verb, from linking contacts together">Link</property>
                                    <property name="tooltip-text" translatable="yes">Link Selected Contacts Together</property>
                                    <property name="action-name">win.link-marked-contacts</property>
                                    <property name="can-shrink">True</property>
                                  </object>
                                </child>
                              </object>
                            </child>
                            <child>
                              <object class="GtkBox">
                                <property name="halign">end</property>
                                <property name="hexpand">True</property>
                                <property name="spacing">6</property>
                                <child>
                                  <object class="GtkButton" id="delete_button">
                                    <property name="focus_on_click">False</property>
                                    <property name="label" translatable="yes">Remove</property>
                                    <property name="action-name">win.delete-marked-contacts</property>
                                    <property name="can-shrink">True</property>
                                    <style>
                                      <class name="destructive-action"/>
                                    </style>
                                  </object>
                                </child>
                              </object>
                            </child>
                          </object>
                        </property>
                      </object>
                    </child>
                  </object>
                </property>
              </object>
            </property>

            <property name="content">
              <object class="AdwNavigationPage" id="contact_pane_page">
                <property name="name">contact-pane</property>
                <property name="child">
                  <object class="AdwToolbarView">
                    <child type="top">
                      <object class="AdwHeaderBar" id="right_header">
                        <child>
                          <object class="GtkButton" id="cancel_button">
                            <property name="visible">False</property>
                            <property name="label" translatable="yes">_Cancel</property>
                            <property name="use_underline">True</property>
                            <property name="action-name">win.edit-contact-cancel</property>
                            <property name="can-shrink">True</property>
                          </object>
                        </child>
                        <child type="end">
                          <object class="GtkBox" id="contact_sheet_buttons">
                            <property name="visible">False</property>
                            <property name="orientation">horizontal</property>
                            <property name="spacing">6</property>
                            <child>
                              <object class="GtkButton" id="edit_contact_button">
                                <property name="icon-name">document-edit-symbolic</property>
                                <property name="action-name">win.edit-contact</property>
                                <property name="tooltip-text" translatable="yes">Edit Contact</property>
                              </object>
                            </child>
                            <child type="end">
                              <object class="GtkMenuButton" id="contact_hamburger_menu_button">
                                <property name="menu-model">contact_hamburger_menu_popover</property>
                                <property name="tooltip_text" translatable="yes">Contact Menu</property>
                                <property name="icon-name">view-more-symbolic</property>
                              </object>
                            </child>
                          </object>
                        </child>
                        <child type="end">
                          <object class="GtkButton" id="done_button">
                            <property name="visible">False</property>
                            <property name="use_underline">True</property>
                            <property name="label" translatable="yes">Done</property>
                            <property name="valign">center</property>
                            <property name="action-name">win.edit-contact-save</property>
                            <property name="can-shrink">True</property>
                            <style>
                              <class name="suggested-action"/>
                            </style>
                          </object>
                        </child>
                      </object>
                    </child>
                    <child>
                      <object class="GtkOverlay" id="contact_pane_container"/>
                    </child>
                  </object>
                </property>
              </object>
            </property>
          </object>
        </child>
      </object>
    </child>
    <child>
      <object class="AdwBreakpoint">
        <condition>max-width: 560sp</condition>
        <setter object="content_box" property="collapsed">True</setter>
      </object>
    </child>
  </template>
</interface>
